#include "algo.h"
#include "list.h"
extern Graph G;
double ** Compute_Leaves_Dist ( Graph );
FILE * fpinput , *fpdistinput;
char *intree;
int **addresses,*name,length;
int nleaves, ninternal, nedge, ninternaledges;
int count_leaves=0,count_edges;

int id1,id2,id3,id4,nodo1,nodo2;

//READ_graph
int read_graph(char *nomefile){
int i=0,j;
char *temp;

fpinput = fopen ( nomefile, "r" ) ;
	
	if ( fpinput == NULL ) {
                fprintf(stderr, "configuration file  %s doesn't exist ... exiting\n", nomefile );
                exit(-1);
        }



intree=(char*) malloc(sizeof(char));

while(fscanf(fpinput,"%c",&temp)!=EOF) {
intree=(char*) realloc(intree,(i+1)*sizeof(char));
*(intree+i)=temp;
i++;
}
intree[i]='\0';

for(j=0;j<i;j++){
fscanf(fpinput,"%c",intree[j]);
}
return i;
}


//FIND_INT_NODES
int find_int_nodes(){

int j,contas=0,scorri=0;
char s2,s3;
int *indsx;
s2='(';
s3=')';
for(j=0;j<length;j++){

if(intree[j]==s2){

contas=contas+1;
name[j]=contas;
addresses[contas][0]=j;
}
}

indsx=(int*)malloc(contas*sizeof(int));
for(j=0;j<length;j++){
if(name[j] !=0){
indsx[scorri]=name[j];
scorri=scorri+1;
}


if(intree[j]==s3){
addresses[indsx[scorri-1]][1]=j;
name[j]=indsx[scorri-1];
scorri--;
}

}
return contas; 

}
 
//RETURN_NODE_ID
void ReturnNodeId( char * sitee1, char **vec, int n, int *id)
{
	int i,flag;
	flag = 0;
	for( i = 0; i<n; i++ ){
		
		if (!strcmp(sitee1,vec[i])){
                        
			flag = 1;
			break;
		}
	}

	if ( flag )
		*id  = i;
	else { 
               
		*id = -1;
		}
}


//PRINT_SONS
void print_sons(int i){
int dx,sx,j,k,scorri=0;
int lsx, ldx;
int namesx,namedx;
int memid1,memid2;
char site1[10000],site2[10000],site3[10000];
sx=addresses[i+1][0];
dx=addresses[i+1][1];


sprintf(site1,"INODE_%d",i);
G.internname[i] = (char * ) malloc ( strlen(site1) * sizeof ( char ) );	
G.Node[i+nleaves].name =  (char * ) malloc ( strlen(site1) * sizeof ( char ) );
strcpy(G.internname[i],site1);
strcpy(G.Node[i+nleaves].name, site1);
G.Node[i+nleaves].id = i + nleaves;





for(j=dx;intree[j]!=':';j--);

if(intree[sx+1]=='\n')sx=sx+1;

//internal node
if(name[sx+1]!=0){memid1=name[sx+1]-1+nleaves;
 G.Node[memid1].neigh[G.Node[memid1].nn]=count_edges;
                                G.Node[memid1].nn++;
}

//leaf
else{

				for(k=addresses[sx][0];intree[k]!=':';k++);
				lsx=0;
				for(namesx=sx+1;intree[namesx]!=':';namesx++)if(intree[namesx] != '\n'){site2[lsx++]=intree[namesx];}
				G.leavesname[count_leaves] = (char * ) malloc ( lsx * sizeof ( char ) );	
				G.Node[count_leaves].name = (char * ) malloc ( lsx * sizeof ( char ) );
				G.Node[count_leaves].labelnewick = (char * ) malloc ( lsx * sizeof ( char ) );
				G.Node[count_leaves].newick = 1;

				strncat (G.leavesname[count_leaves],site2,lsx );
                                strcpy(G.Node[count_leaves].name,G.leavesname[count_leaves]);
				strcpy(G.Node[count_leaves].labelnewick,G.leavesname[count_leaves]);
				G.Node[count_leaves].id = count_leaves;
                                G.Node[count_leaves].neigh[G.Node[count_leaves].nn]=count_edges;
                                G.Node[count_leaves].nn++;
				memid1=count_leaves;;
                                ++count_leaves;



}



if(intree[j-1]=='\n')j=j-1;
for(k=j-1;intree[k]!=',';k--);

//internal node
if(name[j-1]!=0){memid2=name[j-1]-1+nleaves;
 G.Node[memid2].neigh[G.Node[memid2].nn]=count_edges+1;
                                G.Node[memid2].nn++;
}

//leaf
else{
				ldx=0;
                                scorri=0;
				for(namedx=k+1;intree[namedx]!=':';namedx++)if(intree[namedx] != '\n'){site3[ldx++]=intree[namedx];}
				G.leavesname[count_leaves] = (char * ) malloc ( ldx * sizeof ( char ) );	
				G.Node[count_leaves].name = (char * ) malloc ( ldx * sizeof ( char ) );
				G.Node[count_leaves].labelnewick = (char * ) malloc ( ldx * sizeof ( char ) );
				G.Node[count_leaves].newick = 1;
				strncat (G.leavesname[count_leaves],site3,ldx );

				strcpy(G.Node[count_leaves].name,G.leavesname[count_leaves]);
				strcpy(G.Node[count_leaves].labelnewick,G.leavesname[count_leaves]);
				G.Node[count_leaves].id = count_leaves;
                                 G.Node[count_leaves].neigh[G.Node[count_leaves].nn]=count_edges+1;
                                G.Node[count_leaves].nn++;
                                memid2=count_leaves;
                         	++count_leaves;

}
//assigning edges

G.Edge[count_edges].s1=i+nleaves;
G.Edge[count_edges].s2=memid1;
G.Node[i+nleaves].neigh[G.Node[i+nleaves].nn]=count_edges;
G.Node[i+nleaves].nn++;
count_edges++;

G.Edge[count_edges].s1=i+nleaves;
G.Edge[count_edges].s2=memid2;
G.Node[i+nleaves].neigh[G.Node[i+nleaves].nn]=count_edges;
G.Node[i+nleaves].nn++;
count_edges++;
}



//PRINT_ROOT
void print_root(){
int dx,sx,j,k,cn;
int lsx, ldx,lcn,scorri=0;
int namesx,namedx,namecn;
int memid1,memid2,memid3;
char site4[10000],site5[10000],site6[10000],site7[10000];
sx=addresses[1][0];
dx=addresses[1][1];


sprintf(site4,"INODE_0");
G.internname[0] = (char * ) malloc ( strlen(site4) * sizeof ( char ) );	
G.Node[nleaves].name =  (char * ) malloc ( strlen(site4) * sizeof ( char ) );
strcpy(G.internname[0],site4);
strcpy(G.Node[nleaves].name, site4);
G.Node[nleaves].id = nleaves;




if(intree[sx+1]=='\n')sx=sx+1;
				if(name[sx+1]!=0){memid1=name[sx+1]-1+nleaves;
 G.Node[memid1].neigh[G.Node[memid1].nn]=count_edges;
                                G.Node[memid1].nn++;}
else{
				for(k=addresses[sx][0];intree[k]!=':';k++);
				lsx=0;
				for(namesx=sx+1;intree[namesx]!=':';namesx++)if(intree[namesx] != '\n'){site5[lsx++]=intree[namesx];}
				G.leavesname[count_leaves] = (char * ) malloc ( lsx * sizeof ( char ) );	
				G.Node[count_leaves].name = (char * ) malloc ( lsx * sizeof ( char ) );
				G.Node[count_leaves].labelnewick = (char * ) malloc (lsx * sizeof ( char ) );
				G.Node[count_leaves].newick = 1;
				strncat (G.leavesname[count_leaves],site5,lsx );
    
				strcpy(G.Node[count_leaves].name,G.leavesname[count_leaves]);
				strcpy(G.Node[count_leaves].labelnewick,G.leavesname[count_leaves]);
				G.Node[count_leaves].id = count_leaves;
                                G.Node[count_leaves].neigh[G.Node[count_leaves].nn]=count_edges;
                                G.Node[count_leaves].nn++; 
				memid1=count_leaves;
                                ++count_leaves;

}




for(j=dx;intree[j]!=':';j--);
for(k=j-1;intree[k]!=',';k--);
if(intree[j-1]=='\n')j=j-1;

				if(name[j-1]!=0){memid2=name[j-1]-1+nleaves;
 G.Node[memid2].neigh[G.Node[memid2].nn]=count_edges+1;
                                G.Node[memid2].nn++;}
else{				
                                scorri=0;
				ldx=0;
				for(namedx=k+1;intree[namedx]!=':';namedx++)if(intree[namedx] != '\n'){site6[ldx++]=intree[namedx];}
				G.leavesname[count_leaves] = (char * ) malloc ( ldx * sizeof ( char ) );	
				G.Node[count_leaves].name = (char * ) malloc ( ldx * sizeof ( char ) );
				G.Node[count_leaves].labelnewick = (char * ) malloc ( ldx * sizeof ( char ) );
				G.Node[count_leaves].newick = 1;
				strncat (G.leavesname[count_leaves],site6,ldx );
 
				strcpy(G.Node[count_leaves].name,G.leavesname[count_leaves]);
				strcpy(G.Node[count_leaves].labelnewick,G.leavesname[count_leaves]);
				G.Node[count_leaves].id = count_leaves;
                                G.Node[count_leaves].neigh[G.Node[count_leaves].nn]=count_edges+1;
                                G.Node[count_leaves].nn++;
                                memid2=count_leaves;
	
                                ++count_leaves;

}





for(cn=addresses[name[sx+1]][1];intree[cn]!=',';cn++);
if(intree[cn+1]=='\n')cn=cn+1;
if(name[cn+1]!=0){memid3=name[cn+1]-1+nleaves;
 G.Node[memid3].neigh[G.Node[memid3].nn]=count_edges+2;
                                G.Node[memid3].nn++;}

else{
for(k=addresses[cn][0];intree[k]!=':';k++);
lcn=0;
scorri=0;
for(namecn=cn+1;intree[namecn]!=':';namecn++)if(intree[namecn] != '\n'){site7[lcn++]=intree[namecn];}
                                G.leavesname[count_leaves] = (char * ) malloc ( lcn * sizeof ( char ) );	
				G.Node[count_leaves].name = (char * ) malloc ( lcn * sizeof ( char ) );
				G.Node[count_leaves].labelnewick = (char * ) malloc (lcn * sizeof ( char ) );
				G.Node[count_leaves].newick = 1;
				strncat (G.leavesname[count_leaves],site7,lcn );

				strcpy(G.Node[count_leaves].name,G.leavesname[count_leaves]);
				strcpy(G.Node[count_leaves].labelnewick,G.leavesname[count_leaves]);;
				G.Node[count_leaves].id = count_leaves;
                                G.Node[count_leaves].neigh[G.Node[count_leaves].nn]=count_edges+2;
                                G.Node[count_leaves].nn++;
                                memid3=count_leaves;
         
				++count_leaves;


}


//assigning edges

G.Edge[count_edges].s1=nleaves;
G.Edge[count_edges].s2=memid1;
G.Node[nleaves].neigh[G.Node[nleaves].nn]=count_edges;
G.Node[nleaves].nn++;
count_edges++;

G.Edge[count_edges].s1=nleaves;
G.Edge[count_edges].s2=memid2;
G.Node[nleaves].neigh[G.Node[nleaves].nn]=count_edges;
G.Node[nleaves].nn++;
count_edges++;

G.Edge[count_edges].s1=nleaves;
G.Edge[count_edges].s2=memid3;
G.Node[nleaves].neigh[G.Node[nleaves].nn]=count_edges;
G.Node[nleaves].nn++;
count_edges++;



}






void Read_Data(char *nomefile, char *distfile){
int i,j,*index,line_counter;
char line[LINE_LENGTH],**scravec,nomen[10000];
double dist;

length=read_graph(nomefile);

count_edges=0;
addresses=(int **)malloc(2*length*sizeof(int *));
for(i=0;i<2*length;i++)addresses[i]=(int *)malloc(2*sizeof(int));
name=(int*)malloc(length*sizeof(int));

ninternal=find_int_nodes();
nleaves=ninternal+2;
nedge=2*nleaves-3;
ninternaledges=nleaves-3;
G.nnodes = ninternal+nleaves;
G.nleaves = nleaves;
G.nedges=nedge;
G.ninternaledges=ninternaledges;





	
	G.leavesname = (char ** ) malloc ( nleaves * sizeof ( char * ) );
	G.internname = (char ** ) malloc ( ninternal * sizeof ( char * ) );

	allocate_memory_pointed_list(&G.internaledge, G.nedges+1);
	init_pointed_list (&G.internaledge, G.nedges+1 );
	G.Node = ( pnode ) malloc ( ( ninternal + nleaves ) * sizeof( node ) );
	G.Edge = ( pedge ) malloc ( nedge * sizeof( edge) );


	for( i = 0; i< G.nnodes; ++i ){
		G.Node[i].id = -1;
		G.Node[i].nn = 0;
		G.Node[i].nneigh = 0;
		G.Node[i].newick = 0;
		G.Node[i].name = NULL;
		G.Node[i].labelnewick = NULL;
		for(j = 0 ; j<3 ;++j )
			G.Node[i].neigh[j] = 0;
			G.Node[i].siteneigh[j] = 0;
	}
	for( i = 0; i< G.nedges; ++i ){
		G.Edge[i].s1 = -1;
		G.Edge[i].s2 = -1;
		G.Edge[i].dist = 0;
	}

print_root();

for(i=1;i< ninternal;i++){
print_sons(i);
}



	if ( count_leaves != G.nleaves ){
		fprintf(stderr, "in Read_Data() nleaves problems %d %d\n",count_leaves,G.nleaves);
		exit(0);
	}

	if ( count_edges  != nedge ){
		fprintf(stderr, "in Read_Data() ninternal problems\n");
		exit(0);
	}






	for( i = 0; i<G.nedges; ++i ){
		id1 = G.Edge[i].s1;
		id2 = G.Edge[i].s2;
               
 		if ( (G.Node[id1].nn == 3) && (G.Node[id2].nn ==3 )){
			add_pointed_list( &G.internaledge, i );
		}
	}




	if ( G.internaledge.size != G.ninternaledges ){
		fprintf(stderr, "Strange number of internal links %i %i\n", G.internaledge.size,G.ninternaledges);
		exit(-1);
	}

	for( i = 0; i<G.nedges; ++i ){
		id1 = G.Edge[i].s1;
		id2 = G.Edge[i].s2;
		G.Node[id1].siteneigh[G.Node[id1].nneigh]=id2;
		G.Node[id1].nneigh++;
		G.Node[id2].siteneigh[G.Node[id2].nneigh]=id1;
		G.Node[id2].nneigh++;
	}




	for( i = 0; i<G.nnodes; ++i ){
            
		assert(G.Node[i].nneigh <= 3);

		
	}

//reading input_matrix
	fpdistinput = fopen ( distfile, "r" ) ;
	
	if ( fpdistinput == NULL ) {
                fprintf(stderr, "distance file  %s doesn't exist ... exiting\n", distfile );
                exit(-1);
        }

	fgets( line , LINE_LENGTH, fpdistinput);
	sscanf(line,"%d",&i);
	assert( i == G.nleaves );

	

	scravec=(char **) malloc(G.nleaves*sizeof(char *));
	for( i =0; i<G.nleaves; ++i )
		scravec[i]= (char *) malloc(100*sizeof(char ));
	index = (int *) malloc ( G.nleaves * sizeof ( int ) );

		
	line_counter=0;
	for(;; ){
		if ( fgets( line , LINE_LENGTH, fpdistinput ) == NULL ){break;}
		sscanf(line,"%s ", nomen);
		strcpy(scravec[line_counter], nomen);
		ReturnNodeId(nomen, G.leavesname, G.nleaves,&nodo1);
		index[line_counter]=nodo1;
                line_counter++;
	}

	assert(line_counter==G.nleaves);


	rewind(fpdistinput );

	fgets( line , LINE_LENGTH, fpdistinput);
	sscanf(line,"%d",&i);
	assert( i == G.nleaves );

	line_counter=0;
	
	G.leavesdist = (double ** ) malloc ( G.nleaves * sizeof( double * ) );
	for(i=0; i<G.nleaves;i++ ){
		G.leavesdist[i] = (double *)malloc ( G.nleaves * sizeof( double ) );

	}
  

	for(j=0;j<G.nleaves;j++){
		fscanf(fpdistinput,"%s ",nomen);
              //  printf("%s\n",nomen);
		for(i=0;i<G.nleaves;i++){
			fscanf(fpdistinput,"%lf ",&dist);
                         // printf("qui ci arrivo i=%d j=%d letto:%lf\n",index[i],index[j],dist);
		         G.leavesdist[index[j]][index[i]]=dist;
		}
	}


}





