#include "algo.h"
#include "list.h"
extern Graph G;


int *list, N,**visible,ind,count_edges=0,count_int_edges=0;
int nvis,X,Y;
int cherry1,cherry2,contavisible;
int nodo1,id1,id2;
double *R;
double **distances,dist;
Graph G;

//RETURN_NODE_ID
void ReturnId( char * site1, char **vec, int n, int *id)
{
	int i,flag;
	flag = 0;
	for( i = 0; i<n; ++i ){
		
		if (!strcmp(site1,vec[i])){
			flag = 1;
			break;
		}
	}

	if ( flag )
		*id  = i;
	else {
		*id = -1;
		}
}


//compute_R
double compute_R(int node){
int l;
double sum=0.;
for(l=0;l<N;l++)sum+=distances[node][list[l]];
return sum;
}

//update_R
void update_R(){
int i;
for(i=0;i<N-1;i++)R[list[i]]-=(distances[list[i]][cherry1]+distances[list[i]][cherry2])/2;
R[list[N-1]]=compute_R(list[N-1]);
return;
}

//COMPUTE_S
double S(int i,int j){
double value;
value=(N-2)*distances[i][j]-R[i]-R[j];
return value;
}


//compute_visible
void compute_visible(){
int i,j,conta,nodo;
	nodo=-1;
double min;
conta=0;
for(i=0;i<N;i++){

min=32768;
//nodo=i+1;

for(j=0;j<N;j++){if(S(list[i],list[j])<min && i!=j ){
min=S(list[i],list[j]);
nodo=j;
}}

visible[i][0]=list[i];
visible[i][1]=list[nodo];

}
contavisible=N;
return;
}

//update_visible
void update_visible(){
int i,j,**upvisible,nodo,conta;
double min;
nodo=0;

upvisible=(int**)malloc(contavisible*sizeof(int*));
for(i=0;i<contavisible;i++)upvisible[i]=(int*)malloc(2*sizeof(int));

conta=0;

for(i=0;i<contavisible;i++)if(visible[i][0]!=cherry1 && visible[i][0]!=cherry2 && visible[i][1]!=cherry1 && visible[i][1]!=cherry2){

upvisible[conta][0]=visible[i][0];
upvisible[conta++][1]=visible[i][1];
}
min=distances[ind-1][list[0]];
upvisible[conta][0]=ind-1;
upvisible[conta][1]=list[0];
for(j=0;j<N;j++)if(S((ind-1),list[j])<min && (ind-1)!=list[j]){min=S((ind-1),list[j]);
nodo=j;
}
upvisible[conta][1]=list[nodo];
contavisible=conta+1;
for(i=0;i<contavisible;i++){
visible[i][0]=upvisible[i][0];
visible[i][1]=upvisible[i][1];}
free(upvisible);
return;
}



//choose_cherries_NJ
void choose_cherries_NJ(){
int i,j;
double min;
min=S(list[0],list[1]);
cherry1=list[0];
cherry2=list[1];
for(i=0;i<N;i++){
for(j=0;j<N;j++){
if(S(list[i],list[j])<min && S(list[i],list[j])!=0 && i!=j){
min=S(list[i],list[j]);
cherry1=list[i];
cherry2=list[j];
}
}}
return;
}

//choose_cherries_FNJ
void choose_cherries_FNJ(){
int i;
double min;
min=S(visible[0][0],visible[0][1]);
cherry1=visible[0][0];
cherry2=visible[0][1];
for(i=1;i<contavisible;i++){

if(S(visible[i][0],visible[i][1])<min && S(visible[i][0],visible[i][1])!=0){
min=S(visible[i][0],visible[i][1]);
cherry1=visible[i][0];
cherry2=visible[i][1];
}
}}

//update_list
void update_list(){
int i,*uplist,conta;
uplist=(int*)malloc((N-1)*sizeof(int));

conta=0;
for(i=0;i<N;i++)if(list[i]!=cherry1 && list[i]!=cherry2){

uplist[conta++]=list[i];
}
uplist[conta]=ind;
assert( conta+1 == N-1 );

for(i=0;i<N-1;i++)list[i]=uplist[i];
N=N-1;
ind++;
free(uplist);
return;
}





//reduce_matrix
void reduce_matrix(){
int i;


for(i=0;i<N;i++){
if(list[i]!=cherry1 && list[i]!=cherry2){
distances[ind][list[i]]=(distances[cherry1][list[i]]+distances[cherry2][list[i]])/2;
distances[list[i]][ind]=distances[ind][list[i]];}
}

update_list();


return;
}



//add_internal_node
void add_internal_node(int c,int a,int b){
G.Node[c].id = a;
G.Node[c].neigh[G.Node[c].nn++]=count_edges;
G.Node[c].neigh[G.Node[c].nn++]=count_edges+1;
G.Node[a].neigh[G.Node[a].nn++]=count_edges;
G.Node[b].neigh[G.Node[b].nn++]=count_edges+1;
G.Edge[count_edges].s1=c;
G.Edge[count_edges++].s2=a;
G.Edge[count_edges].s1=c;
G.Edge[count_edges++].s2=b;
return;
}


//add_last_node
void add_last_node(){
G.Node[ind].id = ind;
G.Node[ind].neigh[G.Node[ind].nn++]=count_edges;
G.Node[ind].neigh[G.Node[ind].nn++]=count_edges+1;
G.Node[ind].neigh[G.Node[ind].nn++]=count_edges+2;
G.Node[list[0]].neigh[G.Node[list[0]].nn++]=count_edges;
G.Node[list[1]].neigh[G.Node[list[1]].nn++]=count_edges+1;
G.Node[list[2]].neigh[G.Node[list[2]].nn++]=count_edges+2;
G.Edge[count_edges].s1=ind;
G.Edge[count_edges++].s2=list[0];
G.Edge[count_edges].s1=ind;
G.Edge[count_edges++].s2=list[1];
G.Edge[count_edges].s1=ind;
G.Edge[count_edges++].s2=list[2];
return;
}




//FNJ
int FNJ(char *distfile){

char **nomen,line[LINE_LENGTH];
char **scravec,name[10000];
FILE *input;

int num,i,j,a,b,*index,line_counter;
int nleaves, ninternal, nedge, ninternaledges;
input=fopen(distfile,"r");






//reading input matix
if ( input == NULL ) {
                printf("distance file  infile doesn't exist ... exiting\n");
                exit(-1);
        }

        fgets( line , LINE_LENGTH, input);
	sscanf(line,"%d",&num);
        distances=(double **) malloc ((2*num-3) * sizeof( double * ) );
        nomen=(char **) malloc (num*sizeof(char *));
        R=(double *) malloc ((2*num-3) * sizeof( double ) );
        visible=(int **) malloc ((2*num) * sizeof( int * ) );


for(i=0; i<(2*num-2);++i ){
		       distances[i] = (double *)malloc ( (2*num-3) * sizeof( double ) );
                       visible[i] = (int *)malloc (2 * sizeof( int ) );
            
                          }
for(i=0; i<num;++i ){  
nomen[i]=(char *)malloc(1000*sizeof(char));                   

	}
N=num;
ind=num;

for(j=0;j<num;j++){
		fscanf(input,"%s ",nomen[j]);
		for(i=0;i<num;i++){
			fscanf(input,"%lf ",&dist);
		         distances[j][i]=dist;
		}
	}

nleaves=N;
ninternal=N-2;
nedge=2*nleaves-3;
ninternaledges=nleaves-3;
G.nnodes = ninternal+nleaves;
G.nleaves = nleaves;
G.nedges=nedge;
G.ninternaledges=ninternaledges;



	G.leavesname = (char ** ) malloc ( nleaves * sizeof ( char * ) );
	G.internname = (char ** ) malloc ( ninternal * sizeof ( char * ) );

	allocate_memory_pointed_list(&G.internaledge, G.nedges+1);
	init_pointed_list (&G.internaledge, G.nedges+1 );
	G.Node = ( pnode ) malloc ( ( ninternal + nleaves ) * sizeof( node ) );
	G.Edge = ( pedge ) malloc ( nedge * sizeof( edge) );


	for( i = 0; i< G.nnodes; ++i ){
		G.Node[i].id = -1;
		G.Node[i].nn = 0;
		G.Node[i].nneigh = 0;
		G.Node[i].newick = 0;
		G.Node[i].name = NULL;
		G.Node[i].labelnewick = NULL;
		G.Node[i].labelnewick = (char * ) malloc ( 10000 * sizeof ( char ) );

               for(j = 0 ; j<3 ;++j )
			G.Node[i].neigh[j] = 0;
			G.Node[i].siteneigh[j] = 0;
	}
	for( i = 0; i< G.nedges; ++i ){
		G.Edge[i].s1 = -1;
		G.Edge[i].s2 = -1;
		G.Edge[i].dist = 0;
	}



for(i=0;i<N;i++){
G.Node[i].id=i;
G.Node[i].newick=1;
G.leavesname[i] = (char * ) malloc ( strlen(nomen[i]) * sizeof ( char ) );	
G.Node[i].name = (char * ) malloc ( strlen(nomen[i]) * sizeof ( char ) );

strcpy(G.leavesname[i],nomen[i]);
strcpy(G.Node[i].name,nomen[i]);
strcpy(G.Node[i].labelnewick,nomen[i]);
}

rewind(input );


scravec=(char **) malloc(num*sizeof(char *));
for( i =0; i<num; ++i )scravec[i]= (char *) malloc(100*sizeof(char ));
index = (int *) malloc ( num * sizeof ( int ) );
fgets( line , LINE_LENGTH, input);
	sscanf(line,"%d",&i);
	assert( i == G.nleaves );

line_counter=0;
	for(;; ){
		if ( fgets( line , LINE_LENGTH, input ) == NULL ){break;}
		sscanf(line,"%s ", name);
		strcpy(scravec[line_counter], name);
		ReturnId(name, G.leavesname, G.nleaves,&nodo1);
		index[line_counter]=nodo1;
                line_counter++;
	}

	assert(line_counter==G.nleaves);


	




	rewind(input );

	fgets( line , LINE_LENGTH, input);
	sscanf(line,"%d",&i);
	assert( i == G.nleaves );

	line_counter=0;
	
	G.leavesdist = (double ** ) malloc ( G.nleaves * sizeof( double * ) );
	for(i=0; i<G.nleaves;++i ){
		G.leavesdist[i] = (double *)malloc ( G.nleaves * sizeof( double ) );

	}





	for(j=0;j<G.nleaves;j++){
		fscanf(input,"%s ",name);
		for(i=0;i<G.nleaves;i++){
			fscanf(input,"%lf ",&dist);
		         G.leavesdist[index[j]][index[i]]=dist;
		}
	}



list=(int*)malloc(N*sizeof(int));
for(i=0;i<N;i++)list[i]=i;
for(j=0;j<N;j++)R[list[j]]=compute_R(list[j]);


compute_visible();

while(N>3){
choose_cherries_FNJ();
a=cherry1;
b=cherry2;

reduce_matrix();
add_internal_node(ind-1,a,b);
update_R();
update_visible();
}

add_last_node();


	for( i = 0; i<G.nedges; ++i ){
		id1 = G.Edge[i].s1;
		id2 = G.Edge[i].s2;
               
 		if ( (G.Node[id1].nn == 3) && (G.Node[id2].nn ==3 )){
			add_pointed_list( &G.internaledge, i );
		}
	}


	for( i = 0; i<G.nedges; ++i ){
		id1 = G.Edge[i].s1;
		id2 = G.Edge[i].s2;
		G.Node[id1].siteneigh[G.Node[id1].nneigh]=id2;
		G.Node[id1].nneigh++;
		G.Node[id2].siteneigh[G.Node[id2].nneigh]=id1;
		G.Node[id2].nneigh++;
	}




	for( i = 0; i<G.nnodes; ++i ){
            
		assert(G.Node[i].nneigh <= 3);

		
	}


//fclose(input);




return 1;
}




