#define MAIN_C
#include "algo.h"

char * nomefile = NULL;
char * distfile = NULL;
char * nomegrafo = NULL;
int choose;
double beta;
double THRESHOLD;
int X,Y;
Graph G;
int nsweeps;
double deltabeta;


void Read_Data( char *, char * );
void Read_Data_True( char * , char *);
void Mc(char *);
void FNJ(char *);


//READ_INPUT
void Read_Input( int argc, char **argv )
{
        char c;
        nomefile = (char *) malloc( 1000* sizeof( char ));
	distfile = (char *) malloc( 1000* sizeof( char ));
	nomegrafo = (char *) malloc( 1000* sizeof( char ));
        nsweeps=2;
	deltabeta=0.0015;
        while((c=getopt(argc, argv,"s:n:b:i:o:h:"))!=-1 || argc == 1) {
		switch (c) {
		case 's':
			myrand64 = ( unsigned long long ) atoll(optarg);
			break;
		case 'n':
			nsweeps  = atoi(optarg);
			break;
		case 'b':
			deltabeta  =atof(optarg);
			break;
		case 'i':
			distfile  = optarg;
                        break;
		case 'o':
			nomegrafo  = optarg;
                        break;
        	case 'h':
                default:
                        fprintf(stderr, "%s [options]\n"
                                "\t-s\t\t <random seed>\n"
			        "\t-i\t\t <input distance matrix name>\n"
                                "\t-t\t\t < choose 1 to start froma a given tree (default =0)>\n"
                                "\t-f\t\t <input tree name>\n"
			        "\t-o\t\t <output tree name>\n",argv[0]);
	
		       
			exit(1);
                }


        }

	if ( ! myrand64 )
                myrand64 = 123456ULL;

        inv_massimo_rand64 = 1.0 /(double)MASSIMO_RAND64;
	


}


/************************************************/




//MAIN
int main ( int argc, char ** argv )
{



	Read_Input(argc,argv);

FNJ(distfile);
     

	Mc(nomegrafo);
       
return 0;
}
/************************************************/
