#include "list.h"
#include "assert.h"

void free_pointed_list ( punlist mypl ) 
{
  free( mypl.pun );
  free( mypl.vec );
}


void allocate_memory_pointed_list( punlist * mypl , int n )
{

  (*mypl).pun = malloc ( n * sizeof (int ));
  (*mypl).vec = malloc ( n * sizeof (int ));
  (*mypl).size = 0;
}


void init_pointed_list (punlist * mypl, int n )
{
  int i; 

  (*mypl).size = 0;
  for ( i = 0 ; i < n; i ++ ) {
    (*mypl).vec[i] = -12345678;
    (*mypl).pun[i] = -12345678;
  }
}



void add_pointed_list ( punlist * mypl, int i ) 
{
  
  if ( (*mypl).pun[ i ] != -12345678 ) {
    //    printf("element %d already present \n", i);
    return;
    //    exit(-1);
  }
		
	
  (*mypl).vec[(*mypl).size] = i; 
  (*mypl).pun[i] = (*mypl).size; 
  (*mypl).size++;
	
}

void remove_pointed_list ( punlist * mypl, int i ) 
{
  (*mypl).size--;
  (*mypl).vec[(*mypl).pun[i]]  = (*mypl).vec[(*mypl).size]; 
  (*mypl).pun[(*mypl).vec[(*mypl).size]] = (*mypl).pun[i]; 
  (*mypl).pun[i] = -12345678;
}

void fill_pointed_list ( punlist * mypl, int i )
{
  int l;
  
  assert(mypl->size==0);
  for ( l = 0 ; l < i ; l++ ) 
    add_pointed_list ( mypl, l);
}
